// Suresh kumar Devenathan
// mdsuresh@yahoo.com
// (C) GNU Public License
// compilation test program for the blitz library

#define BZ_DEBUG
#include<iostream>
#include<algorithm>

#include<blitz/array.h>
#include <blitz/array/indirect.h>
#include<vector>

#ifdef BZ_NAMESPACES
using namespace blitz;
using namespace std;
#endif



namespace blitz {
  
  inline float abs( float input) {
    return (float) std::fabs( (float) input);
  }
  inline double abs( double input) {
    return (float) std::fabs( (double) input);
  }
  

 /* double log(double  input) {
    return (double) std::log( (double) input);
  }
  
  
  
  template<class T>
  T sqrt( T input) {
    return (T) std::sqrt( (long double) input);
  }
  template<class T>
  T log( T  input) {
    return (T) std::log( (long double) input);
  }
  
  template<class T>
  T pow( T a, int n)
  {
    return (T) std::pow( (long double) a, (long double) n);
  }
  template<class T>
  T floor(  T input) {
    return (T) std::log( (long double) input);
  }

  template<class T>
  T atan( T input) {
    return (T) std::atan( (long double) input);
  }
  template<class T>
  T max( T a, T b) {
    return (T) std::max( (long double) a, (long double) b);
  }
  */
  using std::max;
  using std::atan;
  using std::floor;
  using std::sqrt;
  using std::log;
  using std::exp;
  using std::pow;
  using std::min;
  using std::max;

  inline int  pow(int a, int n)
  {
	  int q = 1;
	  for(int i=0; i < n; i++)
        q*=a;
	  return q;
  }


}

 
#include <blitz/alg/port.h>
#include <blitz/alg/matdefault.h>
#include <blitz/alg/cholesky.cc>
#include <blitz/alg/eigen.cc>
#include <blitz/alg/balance.cc>
#include <blitz/alg/gaussj.cc>
#include <blitz/alg/jacobi.cc>
#include <blitz/alg/fourier.cc>
#include <blitz/alg/elmhes.cc>

/*
#include <blitz/alg/mprove.cc>
*/
#include <blitz/alg/walsh.cc>
#include <blitz/alg/fwt.cc>
#include <blitz/alg/fwt_filter.cc>
#include <blitz/alg/svd.cc>
#include <blitz/alg/lu.cc>
#include <blitz/alg/vander.cc>


struct Sample 
{
  int a, b, c;
  
  Sample()
  {
   a =0;
   b =0;
   c =0;
  } 
 
};

std::ostream& operator<<(std::ostream& out, const Sample& x)  {
      out << x.a << "," << x.b << "," << x.c << "\n";
      return out;
}


	BEGIN_EXPOSE_BLOCK(Sample,int) 
	EXPOSE_MEMBER(a) 
	EXPOSE_MEMBER(b) 
	EXPOSE_MEMBER(c)
	END_EXPOSE_BLOCK         

//EXPOSE_STRUCTURE_C3(Sample, int, a,b,c)




int main()
{
   
  Array<double, 1> vector(8);
   vector  = 1.0,-1.0, 1.0, -1.0, 1.0 , 1.0, 1.0, -1.0;   
   Array<double, 1> result = blitz::walsh(vector);
 //  char c;
   Array<Sample,1> arr_test(8);
   arr_test = Sample();
   Array<int , 1> arr_a = arr_test->b();
   arr_a = 10;

   cout << "Sample arr=" << arr_test << "\n";
   
   std::cout  << vector << "result" << iwalsh(result) << "\n";
   
  // //Test<Sample, 1> q;
//   //Array<int, 1>  arr_a = q->a();
//   
//   
//   
//   //std::vector<int> A(3);
//  // A  =  {0, 4 , 5};
//   
//  //result[ indexSet(A) ] = vector;
   Array<complex<double> , 2> fft_input(8,2);
//  
    fft_input =  4,4,
                -3,-3,
                2,2 ,
                 0,0 ,
              -1,-1,
               -2,-2,
                3,3,
                1,1
                   ;

    Array<complex<double> , 1> fft_input_uno(8);
//  
    fft_input_uno =  4,      -3,    2,    0,  -1,  -2,    3,    1  ;
//   
	cout <<  "1 dim fft = " << blitz::fft(fft_input_uno) << "\n";
//   
//    
    Array<double,2> a(6,6), b(6,6);
   
	a =  delim<'['>(),  10 ,    5,     9,     4,     1,     0,
                       2 ,     0,     7,     9,     2,     7,
                       6 ,    8,     2,     1,     2,      4,
                       5 ,     4,     4,     4,     6,     9,
                       9 ,     6,     9,     8,     3,     5,
					   8 ,     8,     9,     0,     2,     4, delim<']'>();

	Array<double,2> k(6,8);
	

	k =  delim<'['>(),  10 ,    5,     9,     4,     1,    delim<';'>(),
                       2 ,     0,     7,     9,     2,     delim<';'>(),
                       6 ,    8,     2,     1,     2,      delim<';'>(),
                       5 ,     4,     4,     4,     6,     delim<';'>(),
                       9 ,     6,     9,     8,     3,     delim<';'>(),
					   8 ,     8,     9,     0,     2,     delim<';'>(),
					   delim<']'>();

	cout << "k=" << k;

       
     b = a.copy();
	 
//       
//   cout << a;
//   
//   
///*  
   Array<complex<double> , 2> fft_;

   
    fft_.reference( blitz::fft(fft_input));
   cout << fft_ << "\n";
//  cout << "walsh" << result;
//  
//  cout << "walsh inverse";
//  
//  cout << blitz::iwalsh(result);
//   
//   
   cout << "inv" << blitz::ifft(fft_) << "\n";
  
   cout << "end";
//   
//   //cout << result[ indexSet( A)] << "\n";
//   
//   
//  
//   // cin >> c;     
   
       a = blitz::inv(a);
      cout << "Matrix_Inverse=" ;
      cout << a;
//    
    Array<double, 2>  wavelet_input(8,2), wavelet_output;
    wavelet_input =  4,4,
                    -3,-3,
                     2,2 ,
                     0,0 ,
                    -1,-1,
                    -2,-2,
                    3,3,
                   1,1
                     ;
                     
    Array<double,1>  filter;
    filter.reference( blitz::makeOnFilter("Daubechies",4, double())) ;
    cout << "out";
    cout << filter << "\n";
    
                     
    cout << blitz::downlo(wavelet_input,filter) << "\n";
	cout << blitz::downhi(wavelet_input,blitz::mirrorfilter(filter)) << "\n";

	wavelet_output.reference(blitz::fwt_po(wavelet_input,1,filter));

    
	cout << wavelet_output << "\n" ;

	Array<double,2> f(8,8);

	Array<double,2> i_f(8,8);
	
	f=  3,     8,     8,     8,     7,     9,     1,     3,
     8,     6,     0,    10,     6,     8,     3,     5,
     5,     1,     9,     5,     4,     9,     9,     1,
     2,     9,     7,     0,     2,     6,     6,     3,
     2,     7,     5,     0,     5,     6,    10,     3,
     1,     4,     7,    10,     7,     0,     2,     7,
     2,     0,     4,     4,     9,     6,    10,     5,
     5,     3,     9,     8,     3,     5,    10,     8;

	i_f=  blitz::fwt2_po( f, 0, filter);

	cout   << "fwt2_po =" <<  i_f << "\n";
	cout   << "iwt2_po =" <<  blitz::iwt2_po( i_f, 0, filter);

//    
   Array<double,2>  back =  blitz::iwt_po(wavelet_output,1, filter);
//   
    cout << back << "\n";
//   
   Array<double,2> S , D;
   Array<double,1> V;
   
        
   
    lhs(ref(S),ref(V),ref(D)) = blitz::svd(a);
      
     cout << "S=" << S << "\n"
          << "V=" << V << "\n"
          << "D=" << D ;

	 //cout << "pinv=" << blitz::pinv(a,0.0001);
          

   lhs(ref(S),ref(V),ref(D)) = blitz::svd(b);
      
     cout << "S=" << S << "\n"
          << "V=" << V << "\n"
          << "D=" << D ;
          
//          
    cout << "pinv=" << blitz::pinv(a, 0.00001);
//   
   Array<double,2> lu_decomp(6,6), ch_decomp(6,6), ch_mat(6,6);
   Array<double,1> ch_p(6);
   lu_decomp = a;
   cout << "lu = " << b;
   lu_decomp = blitz::luinv(lu_decomp);
   
    cout   << "lu_decomp=" << lu_decomp;

	ch_decomp  = sum(  b(blitz::tensor::i, blitz::tensor::k) 
		             * b(blitz::tensor::j, blitz::tensor::k),  tensor::k);
	cout << ch_decomp << "\n";


	blitz::lhs( blitz::ref(ch_mat) , ch_p) = blitz::chol( ch_decomp);

	cout << "ch_decomp=" << ch_mat << "p=" << ch_p;

	Array<double,2> eigen_1(6,6), eigen_2;
	Array<double,1> eigen_e(6);

	lhs(ref(eigen_2), ref(eigen_e) ) = blitz::tridiag(ch_decomp);
	
	cout << "eigen_e=" << eigen_e << "\n" 
		 << "eigen_v=" << eigen_2 << "\n";
	

    
	lhs(ref(eigen_e), ref(eigen_2) )  = jacobi(ch_decomp);

	cout << "eigen_e=" << eigen_e << "\n" 
		 << "eigen_v=" << eigen_2 << "\n";
	cout << blitz::balance(b);

	cout << blitz::hess( ch_decomp );

	
	Array<double,1> x(6), y(6);
	x = 83 ,  50,    71,    43,    30,    19;
	y = 19 ,  68,    30,    54,    15,    70;

	cout << "coeff = " << blitz::vander(x,y);

	

	//cout << "eigen =" << eigen_1;





//    
//     Array<double,2> fwt_mat_test(4,4), ifwt_mat_test;
//     
//     fwt_mat_test = 8* tensor::i + 4*tensor::j;
//     cout << fwt_mat_test << "\n";
//     
//     ifwt_mat_test.reference(blitz::fwt2_po(fwt_mat_test, 1, filter));
//     
//     cout << ifwt_mat_test;
//     
//     fwt_mat_test.reference(blitz::iwt2_po(ifwt_mat_test, 1, filter));
//       cout << fwt_mat_test;
//       
// 
	 Array<double,3> slice_test(5,5,2);

	 slice_test = 0;
	 slice_test(3, Range::all() ) = 1.0; 




	 //slice_test(4, Range::all() ) 

	 cout << slice_test;





     char c;
     cin >> c;
     return 0;
}

//#include <blitz/alg/mat_eigen.c>
